
//
// CustomSurrogate.cs
//    Simple example of a custom COM+ Surrogate.
//
// Author:
//    Tomas Restrepo (tomasr@mvps.org)
//

using System;
using System.Diagnostics;
using System.EnterpriseServices;
using System.Runtime.InteropServices;

namespace Winterdom.EnterpriseServices.Samples
{
   public sealed class ComPlusUtil
   {
      [ DllImport("ole32.dll", PreserveSig=false) ]
      public static extern int CoRegisterSurrogateEx(ref Guid appId, IntPtr unused);

   } // class ComPlusUtil

   public class CustomSurrogate
   {

      public static void Main()
      {
         Console.WriteLine("Starting Surrogate....");
         Console.WriteLine("Process ID: " + Process.GetCurrentProcess().Id);

         Guid APP_ID = new Guid("a0817e7f-032c-4bce-9743-c4327b97ea18");
         int hres = ComPlusUtil.CoRegisterSurrogateEx(ref APP_ID, IntPtr.Zero);
         if ( hres != 0 )
            throw new COMException("CoRegisterSurrogateEx() Failed", hres);
      }
   } // class CustomSurrogate

} // namespace Winterdom.EnterpriseServices.Samples

